Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_clouds.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_clouds.f90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_clouds.f90	(revision 3083)
@@ -433,27 +448,26 @@
     !! Compute the tendency of _clouds_ related moments through sedimentation process.
     !!
-    !! The method computes the tendencies of moments related to cloud microphysics through 
-    !! sedimentation process. The algorithm used here differs from 
-    !! [[mm_haze(module):mm_haze_sedimentation(subroutine)]] as all moments settle with the same 
-    !! terminal velocity which is computed with the average drop radius of the size distribution. 
-    !! We simply compute an _exchange matrix_ that stores the new positions of each cells through 
+    !! The method computes the tendencies of moments related to cloud microphysics through
+    !! sedimentation process. The algorithm used here differs from
+    !! [[mm_haze(module):mm_haze_sedimentation(subroutine)]] as all moments settle with the same
+    !! terminal velocity which is computed with the average drop radius of the size distribution.
+    !! We simply compute an _exchange matrix_ that stores the new positions of each cells through
     !! sedimentation process and then computes the matrix
     !! product with input moments values to get final tendencies.
     REAL(kind=mm_wp), INTENT(out), DIMENSION(:)   :: dm0n
-      !! Tendency of the 0th order moment of the ccn distribution (\(m^{-3}\)). 
+    !! Tendency of the 0th order moment of the ccn distribution (\(m^{-3}\)).
     REAL(kind=mm_wp), INTENT(out), DIMENSION(:)   :: dm3n
-      !! Tendency of the 3rd order moment of the ccn distribution (\(m^{3}.m^{-3}\)). 
+    !! Tendency of the 3rd order moment of the ccn distribution (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp), INTENT(out), DIMENSION(:,:) :: dm3i
-      !! Tendencies of the 3rd order moment of each ice component of the cloud (\(m^{3}m^{-3}\)). 
+    !! Tendencies of the 3rd order moment of each ice component of the cloud (\(m^{3}m^{-3}\)).
     INTEGER                                   :: im,nm
     REAL(kind=mm_wp), DIMENSION(:,:), ALLOCATABLE :: moms, momsf,chg_matrix
+
     nm = 2 + mm_nesp
     ALLOCATE(moms(mm_nla,nm),momsf(mm_nla,nm),chg_matrix(mm_nla,mm_nla))
-    ! Initializes moms 
+    ! Initializes moms
     moms(:,1)  = mm_m0ccn * mm_dzlev
     moms(:,2)  = mm_m3ccn * mm_dzlev
-    DO im=1,mm_nesp
-      moms(:,2+im) = mm_m3ice(:,im) * mm_dzlev
-    ENDDO
+    DO im=1,mm_nesp ; moms(:,2+im) = mm_m3ice(:,im) * mm_dzlev ; ENDDO
     ! Computes exchange matrix
     CALL exchange(mm_drad,mm_drho,mm_dt,chg_matrix)
@@ -463,7 +477,5 @@
     dm0n = (momsf(:,1)-moms(:,1))/mm_dzlev
     dm3n = (momsf(:,2)-moms(:,2))/mm_dzlev
-    DO im=1,mm_nesp
-      dm3i(:,im) = (momsf(:,2+im)-moms(:,2+im))/mm_dzlev
-    ENDDO
+    DO im=1,mm_nesp ; dm3i(:,im) = (momsf(:,2+im)-moms(:,2+im))/mm_dzlev ; ENDDO
     RETURN
   END SUBROUTINE mm_cloud_sedimentation
@@ -472,33 +484,36 @@
     !! Compute the exchange matrix.
     !!
-    !! The subroutine computes the matrix exchange used by 
-    !! [[mm_clouds(module):mm_cloud_sedimentation(subroutine)]] to compute moments tendencies 
-    !! through sedimentation process. Both __rad__ and __rhog__ must be vector with relevant 
+    !! The subroutine computes the matrix exchange used by
+    !! [[mm_clouds(module):mm_cloud_sedimentation(subroutine)]] to compute moments tendencies
+    !! through sedimentation process. Both __rad__ and __rhog__ must be vector with relevant
     !! values over the atmospheric vertical structure. __matrix__ is square 2D-array with same
     !! dimension size than __rad__.
     REAL(kind=mm_wp), INTENT(in), DIMENSION(:) :: rad
-      !! Cloud drop radius over the atmospheric vertical structure (m).
+    !! Cloud drop radius over the atmospheric vertical structure (m).
     REAL(kind=mm_wp), INTENT(in), DIMENSION(:) :: rhog
-      !! Cloud drop density over the atmospheric vertical structure (\(kg.m^{-3}\)).
+    !! Cloud drop density over the atmospheric vertical structure (\(kg.m^{-3}\)).
     REAL(kind=mm_wp), INTENT(in)               :: dt
-      !! Timestep (s).
+    !! Timestep (s).
     REAL(kind=mm_wp), INTENT(out)              :: matrix(:,:)
-      !! The output _exchange matrix_.
-    INTEGER                                 :: nz,i,j,jj,jinf,jsup
+    !! The output _exchange matrix_.
+    INTEGER                                     :: nz,i,j,jj,jinf,jsup
     REAL(kind=mm_wp)                            :: zni,znip1,xf,xft,xcnt
     REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE :: puit
     REAL(kind=mm_wp)                            :: cpte,cpte2
-    INTEGER, PARAMETER                      :: ichx  = 1
+    REAL(kind=mm_wp)                            :: zsurf
+    INTEGER, PARAMETER                          :: ichx  = 1
     matrix = 0._mm_wp ; nz = SIZE(rad) ; ALLOCATE(puit(nz))
-    ! compute exchange matrix 
+    zsurf = mm_zlev(nz)
+    
+    ! compute exchange matrix
     DO i=1,nz
       puit(i) = 0._mm_wp
       xcnt = 0._mm_wp
-      ! computes drop move (i.e. its new positions) 
-      CALL getnzs(ichx,i,rad,rhog,dt,zni,znip1) 
-
-      ! Peculiar case : Ground level precipitation [znip1<0 && (zni<0 || zni>0)]
-      ! Complete precipitation [ znip1 <= 0 && zni <= 0 ] :
-      IF(zni<=0._mm_wp.and.znip1<=0._mm_wp) THEN 
+      ! computes drop move (i.e. its new positions)
+      CALL getnzs(ichx,i,rad,rhog,dt,zni,znip1)
+
+      ! Peculiar case : Ground level precipitation [znip1 < zsurf && (zni < zsurf || zni > zsurf)]
+      ! - complete precipitation [ znip1 <= 0 && zni <= 0 ] :
+      IF(zni <= zsurf .and. znip1 <= zsurf) THEN
         xft=0._mm_wp
         xf=1._mm_wp
@@ -506,21 +521,25 @@
         puit(i)=puit(i)+xf
       ENDIF
-      ! partial precipitation [ znip1 <= 0 && zni > 0 ] :
-      IF (zni>0._mm_wp .and. znip1 <= 0._mm_wp) THEN
-        xft=zni/(zni-znip1)
+      ! - partial precipitation [ znip1 <= zsurf && zni > zsurf ] :
+      IF (zni > zsurf .and. znip1 <= zsurf) THEN
+        xft=(zni-zsurf)/(zni-znip1)
         xf=(1.-xft)
         xcnt=xcnt+xf
         puit(i)=puit(i)+xf
       ENDIF
-      ! General case: no ground precipitation [ znip1 > 0 && zni > 0 ]
-      IF (zni>0._mm_wp.and.znip1>0._mm_wp) THEN
-        xft = 1._mm_wp       ! on a la totalite de la case
+      ! General case : no ground precipitation [ znip1 > zsurf && zni > zsurf ]
+      IF (zni > zsurf .and. znip1 > zsurf) THEN
+        xft = 1._mm_wp ! on a la totalite de la case
         xf  = 0._mm_wp
         xcnt=xcnt+xf
         puit(i)=puit(i)+xf
       ENDIF
-      ! Fix minimum level to the ground 
-      znip1 = MAX(znip1,0.)
-      zni   = MAX(zni,0.)
+      IF (zni < znip1) THEN
+        WRITE(*,'("[EXCHANGES] WARNING, missing this case :",2(2X,ES10.3))') zni, znip1
+      ENDIF
+      
+      ! Fix minimum level to the ground
+      znip1 = MAX(znip1,zsurf)
+      zni   = MAX(zni,zsurf)
       ! Locate new "drop" position in the verical grid
       jsup=nz+1
@@ -531,18 +550,18 @@
       ENDDO
       ! Volume is out of range: (all drops have touched the ground!)
-      ! Note: can happen here,it has been treated previously :)
-      IF (jsup>=nz+1.and.jinf==jsup) THEN 
+      ! Note: cannot happen here, it has been treated previously :)
+      IF (jsup>=nz+1.and.jinf==jsup) THEN
         WRITE(*,'(a)') "[EXCHANGE] speaking: The impossible happened !"
         call EXIT(666)
       ENDIF
       ! Volume inside a single level
-      IF (jsup==jinf.and.jsup<=nz) THEN 
+      IF (jsup==jinf.and.jsup<=nz) THEN
         xf=1._mm_wp
         xcnt=xcnt+xft*xf
         matrix(jinf,i)=matrix(jinf,i)+xft*xf
-      ENDIF 
-  
-      ! Volume over 2 levels 
-      IF (jinf==jsup+1) THEN 
+      ENDIF
+
+      ! Volume over 2 levels
+      IF (jinf==jsup+1) THEN
         xf=(zni-mm_zlev(jinf))/(zni-znip1)
         xcnt=xcnt+xf*xft
@@ -556,5 +575,5 @@
         ENDIF
       ENDIF
-  
+
       ! Volume over 3 or more levels
       IF (jinf > jsup+1) THEN
@@ -573,7 +592,8 @@
           matrix(jj,i)=matrix(jj,i)+xft*xf
         ENDDO
-      ENDIF 
-    ENDDO 
-    ! checking if everything is alright if debug enabled... 
+      ENDIF
+    ENDDO
+
+    ! checking if everything is alright if debug enabled...
     IF (mm_debug) THEN
       cpte=0._mm_wp ; cpte2=0._mm_wp
@@ -582,12 +602,12 @@
           cpte=cpte+matrix(jj,j)
         ENDDO
-        cpte2=cpte+puit(j)
       ENDDO
+      cpte2=cpte+sum(puit)
       IF (abs(cpte2-nz)>1.e-4_mm_wp) THEN
-        WRITE(*,'(a)')"[EXCHANGE] speaking :"
-        WRITE(*,'("tx expl (/nz):",2(2X,ES10.3))') cpte,cpte2
+        WRITE(*,'("[EXCHANGE] speaking: tx expl (/nz):",2(2X,ES10.3))') cpte,cpte2
       ENDIF
     ENDIF
-    RETURN 
+
+    RETURN
   END SUBROUTINE exchange
 
@@ -595,5 +615,5 @@
     !! Compute displacement of a cell under sedimentation process.
     !!
-    !! The method computes the new position of a _drop cell_ through sedimentation process as 
+    !! The method computes the new position of a _drop cell_ through sedimentation process as
     !! descibed in the following scheme:
     !!
@@ -604,25 +624,26 @@
     !! @note
     !! The method uses directly [[mm_globals(module):mm_play(variable)]], [[mm_globals(module):mm_plev(variable)]],
-    !! [[mm_globals(module):mm_temp(variable)]],[[mm_globals(module):mm_btemp(variable)]], 
+    !! [[mm_globals(module):mm_temp(variable)]],[[mm_globals(module):mm_btemp(variable)]],
     !! [[mm_globals(module):mm_zlay(variable)]] and [[mm_globals(module):mm_zlev(variable)]] and uses __idx__ to
     !! get the relevant value to use on the vertical grid.
     INTEGER, INTENT(in)                        :: ichx
-      !! Velocity extrapolation control flag (0 for linear, 1 for exponential -preferred -).
+    !! Velocity extrapolation control flag (0 for linear, 1 for exponential -preferred -).
     INTEGER, INTENT(in)                        :: idx
-      !! Initial position of the drop (subscript of vertical layers vectors).
+    !! Initial position of the drop (subscript of vertical layers vectors).
     REAL(kind=mm_wp), INTENT(in), DIMENSION(:) :: rad
-      !! Cloud drop radius over the atmospheric vertical structure (m).
+    !! Cloud drop radius over the atmospheric vertical structure (m).
     REAL(kind=mm_wp), INTENT(in), DIMENSION(:) :: rho
-      !! Cloud drop density over the atmospheric vertical structure (\(kg.m^{-3}\)).
+    !! Cloud drop density over the atmospheric vertical structure (\(kg.m^{-3}\)).
     REAL(kind=mm_wp), INTENT(in)               :: dt
-      !! Timestep (s).
+    !! Timestep (s).
     REAL(kind=mm_wp), INTENT(out)              :: zni
-      !! Final layer center position (m).
+    !! Final layer upper boundary position (m).
     REAL(kind=mm_wp), INTENT(out)              :: zns
-      !! Final layer upper boundary position (m).
-    REAL(kind=mm_wp)            :: ws,wi,w,zi,zs 
+    !! Final layer lower boundary position (m).
+    REAL(kind=mm_wp)            :: ws,wi,w,zi,zs
     REAL(kind=mm_wp)            :: alpha,argexp,v0,arg1,arg2
     INTEGER                 :: i,nz
     REAL(kind=mm_wp), PARAMETER :: es = 30._mm_wp
+
     nz = SIZE(rad)
     ! Linear extrapolation of velocity
@@ -636,7 +657,7 @@
         ! velocity lower interface
         wi = wsettle(mm_plev(idx+1),mm_btemp(idx+1),mm_zlev(idx+1), &
-                     rho(idx+1),rad(idx+1))
-      ELSE 
-        WRITE(*,'(a)') "[getnzs] speaking:" 
+          rho(idx+1),rad(idx+1))
+      ELSE
+        WRITE(*,'(a)') "[getnzs] speaking:"
         WRITE(*,'(a)') "This is the fatal error..."
         WRITE(*,'(a)') "index is higher than number of levels"
@@ -647,20 +668,21 @@
       zns = mm_zlev(idx)-mm_dzlev(idx)-w*dt
       RETURN
-    ! Exponential extrapolation of velocity
+      ! Exponential extrapolation of velocity
+
     ELSEIF(ichx==1) THEN
-      ws = wsettle(mm_plev(idx),mm_btemp(idx),mm_zlev(idx),rho(idx),rad(idx))
       zs = mm_zlev(idx)
-      wi = wsettle(mm_play(idx),mm_temp(idx),mm_zlay(idx),rho(idx),rad(idx))
+      ws = wsettle(mm_plev(idx),mm_btemp(idx),zs,rho(idx),rad(idx))
       zi=mm_zlay(idx)
+      wi = wsettle(mm_play(idx),mm_temp(idx),zi,rho(idx),rad(idx))
       ! ws & wi must be different !
       IF(dabs(wi-ws)/wi <= 1.e-3_mm_wp)  wi=ws/1.001_mm_wp
       IF (wi /= 0._mm_wp) alpha = dlog(ws/wi)/(zs-zi)  ! alpha < 0 if wi > ws
-      !   -es < argexp < es 
-      argexp=MAX(MIN(alpha*zs,es),-es) 
+      !   -es < argexp < es
+      argexp=MAX(MIN(alpha*zs,es),-es)
       v0 = ws/dexp(argexp)
       arg1=1._mm_wp+v0*alpha*dexp(argexp)*dt
       argexp=MAX(MIN(alpha*(mm_zlev(idx)-mm_dzlev(idx)),es),-es)
       arg2=1._mm_wp+v0*alpha*dexp(argexp)*dt
-      IF (arg1<=0._mm_wp.OR.arg2<=0._mm_wp) THEN 
+      IF (arg1<=0._mm_wp.OR.arg2<=0._mm_wp) THEN
         ! correct velocity
         ! divides the velocity argument in arg1 and arg2 :
@@ -669,9 +691,9 @@
         DO i=1,25
           IF (arg1<=0._mm_wp.OR.arg2<=0._mm_wp) THEN
-            IF (mm_debug) & 
-            WRITE(*,'((a),I2.2,(a))') "[getnzs] must adjust velocity (",i,"/25)"
+            IF (mm_debug) &
+              WRITE(*,'((a),I2.2,(a))') "[getnzs] must adjust velocity (iter:",i,"/25)"
             arg1=(arg1+1._mm_wp)/2._mm_wp ; arg2=(arg2+1._mm_wp)/2._mm_wp
           ELSE
-            EXIT 
+            EXIT
           ENDIF
         ENDDO
@@ -683,14 +705,16 @@
         ENDIF
       ENDIF
+
       zni = mm_zlev(idx)-dlog(arg1)/alpha
       zns = mm_zlev(idx)-mm_dzlev(idx)-dlog(arg2)/alpha
+
       RETURN
-    ENDIF  
+    ENDIF
   END SUBROUTINE getnzs
 
   ELEMENTAL FUNCTION wsettle(p,t,z,rho,rad) RESULT(w)
-    !! Compute the settling velocity of a spherical particle. 
-    !!
-    !! The method computes the effective settling velocity of spherical particle of 
+    !! Compute the settling velocity of a spherical particle.
+    !!
+    !! The method computes the effective settling velocity of spherical particle of
     !! radius __rad__. It accounts for the slip-flow transition (no approximation).
     REAL(kind=mm_wp), INTENT(in) :: p   !! The pressure level (Pa).
@@ -700,16 +724,17 @@
     REAL(kind=mm_wp), INTENT(in) :: rad !! Radius of the particle (m).
     REAL(kind=mm_wp) :: w               !! Settling velocity (\(m.s^{-1}\)).
-    REAL(kind=mm_wp)            :: g,a,kn,nu 
-    REAL(kind=mm_wp), PARAMETER :: ra = 1.75e-10_mm_wp, nu0 = 1.74e-4_mm_wp, c = 109._mm_wp
-    ! Computes corrected gravity
-    g = mm_effg(z)
-    ! Knudsen number
-    kn = mm_kboltz*t/(p*4._mm_wp*sqrt(2._mm_wp)*mm_pi*ra**2)/rad
-    ! Air viscosity
-    nu=nu0*sqrt(t/293._mm_wp)*(1._mm_wp+c/293._mm_wp)/(1._mm_wp+c/t)
+    REAL(kind=mm_wp) :: Us, Fc
+    
+    ! Computes Stokes settling velocity
+    Us = (2._mm_wp * rad**2 * rho * mm_effg(z)) / (9._mm_wp * mm_eta_g(t))
+    
+    ! Apply slip-flow correction
+    Fc = 1 + (mm_akn * mm_lambda_g(t,p) / rad)
+
     ! Computes settling velocity
-    w = 2._mm_wp/9._mm_wp * rad**2*g*rho/nu
-    ! apply slip-flow correction
-    w = w*(1._mm_wp+1.2517_mm_wp*kn+0.4_mm_wp*kn*dexp(-1.1_mm_wp/kn)) 
+    w = Us * Fc
+    !>>> [TEMPO : BBT]
+    !w = Us * Fc * 5.
+    !<<< [TEMPO : BBT]
   END FUNCTION wsettle
 
@@ -723,11 +748,11 @@
     !!
     !! @note
-    !! The computed flux is always positive. 
+    !! The computed flux is always positive.
     REAL(kind=mm_wp), INTENT(in)               :: rho
-      !! Tracer density (\(kg.m^{-3}\)).
+    !! Tracer density (\(kg.m^{-3}\)).
     REAL(kind=mm_wp), INTENT(in), DIMENSION(:) :: m3
-      !! Vertical profile of the total volume of tracer (i.e. M3) from __TOP__ to __GROUND__ (\(m^{3}.m^{-3}\)).
+    !! Vertical profile of the total volume of tracer (i.e. M3) from __TOP__ to __GROUND__ (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp), DIMENSION(SIZE(m3)) :: flx
-      !! Mass sedimentation fluxes at each layer from __TOP__ to __GROUND__ (\(kg.m^{-2}.s^{-1}\)).
+    !! Mass sedimentation fluxes at each layer from __TOP__ to __GROUND__ (\(kg.m^{-2}.s^{-1}\)).
     REAL(kind=mm_wp), SAVE :: fac = 4._mm_wp/3._mm_wp * mm_pi
     flx = fac * rho * m3 * wsettle(mm_play,mm_temp,mm_zlay,mm_drho,mm_drad)
